# -*- coding: utf-8 -*-

import requests
from exception import ConnectionError
import json

URL = 'http://pokeapi.co/api/v2/'

class Pokemon(object):

    def __init__(self, id):
        self.id = id

    def get_api_url(self, url):
        return URL + '{}'.format(url)

    def description(self):
        try:
            request = requests.get(self.get_api_url('pokemon/{}').format(self.id)).json()
        except:
            raise ConnectionError('Connection failed!')
        return request

    def abilities(self):
        try:
            request = requests.get(self.get_api_url('ability/{}').format(self.id)).json()
        except:
            raise ConnectionError('Connection failed!')
        return request

    def characteristics(self):
        try:
            request = requests.get(self.get_api_url('characteristic/{}').format(self.id)).json()
        except:
            raise ConnectionError('Connection failed!')
        return request

    def egg_groups(self):
        try:
            request = requests.get(self.get_api_url('egg-group/{}').format(self.id)).json()
        except:
            raise ConnectionError('Connection failed!')
        return request

    def genders(self):
        try:
            request = requests.get(self.get_api_url('gender/{}').format(self.id)).json()
        except:
            raise ConnectionError('Connection failed!')
        return request

    def growth_rates(self):
        try:
            request = requests.get(self.get_api_url('growth-rate/{}').format(self.id)).json()
        except:
            raise ConnectionError('Connection failed!')
        return request

    def natures(self):
        try:
            request = requests.get(self.get_api_url('nature/{}').format(self.id)).json()
        except:
            raise ConnectionError('Connection failed!')
        return request

    def pokeathlon_stats(self):
        try:
            request = requests.get(self.get_api_url('pokeathlon-stat/{}').format(self.id)).json()
        except:
            raise ConnectionError('Connection failed!')
        return request

    def forms(self):
        try:
            request = requests.get(self.get_api_url('pokemon-form/{}').format(self.id)).json()
        except:
            raise ConnectionError('Connection failed!')
        return request

    def colors(self):
        try:
            request = requests.get(self.get_api_url('pokemon-color/{}').format(self.id)).json()
        except:
            raise ConnectionError('Connection failed!')
        return request

    def forms(self):
        try:
            request = requests.get(self.get_api_url('pokemon-form/{}').format(self.id)).json()
        except:
            raise ConnectionError('Connection failed!')
        return request

    def habitats(self):
        try:
            request = requests.get(self.get_api_url('pokemon-habitat/{}').format(self.id)).json()
        except:
            raise ConnectionError('Connection failed!')
        return request

    def shapes(self):
        try:
            request = requests.get(self.get_api_url('pokemon-shape/{}').format(self.id)).json()
        except:
            raise ConnectionError('Connection failed!')
        return request

    def species(self):
        try:
            request = requests.get(self.get_api_url('pokemon-species/{}').format(self.id)).json()
        except:
            raise ConnectionError('Connection failed!')
        return request

    def stats(self):
        try:
            request = requests.get(self.get_api_url('stat/{}').format(self.id)).json()
        except:
            raise ConnectionError('Connection failed!')
        return request

    def types(self):
        try:
            request = requests.get(self.get_api_url('type/{}').format(self.id)).json()
        except:
            raise ConnectionError('Connection failed!')
        return request
